/*************************************************************************
 ** Codels called by execution task visuservServoingTask
 ** Author: N ouadah
 ** Date: 03 02 2008
 ************************************************************************/

#include <portLib.h>
#include "server/visuservHeader.h"

extern "C" {
#include "meschach/matrix.h"
#include "meschach/matrix2.h"
#include "codels/Mytools.c"
}

static double epa=0, eta=0,  sep=0,  set=0,pan_old=0.0;
static MAT *C=MNULL,*Ccst=MNULL,*Cvar=MNULL,*Cmix=MNULL;

#define VISUSERV_TIMEZONE    NULL

static ICU_VISUAL_DATA s_zero;
static const VISUSERV_ROBOT_CONFIGURATION_STR q_zero={0.0,0.0,0.0,0.0,0.0};
static const VISUSERV_ROBOT_CONTROLS_STR dot_q_zero={0.0,0.0,0.0,0.0};

static VISUSERV_ROBOT_CONFIGURATION_STR q;
static ICU_VISUAL_DATA s;
static VISUSERV_ROBOT_CONTROLS_STR dot_q;
static VISUSERV_ROBOT_CONTROLS_STR dot_q_old;
static int estimator_step=0,ss=0, visualServoing_watchdog=0;

/*! The vs time mesurment*/
static struct timeval vs_start;
static struct timeval vs_end;
static double vs_elapsed=0.0;

/*! The Track time mesurment*/
static struct timeval tr_tmp;
static struct timeval vs_tmp;
static int seca=0,useca=0;
static float dt=0.0,tmp=0.0,ti=0.0;

static FILE *vsData= NULL,  *ptData= NULL;

/* simplex test*/
static MAT *JS=MNULL;
static VEC *Cost=VNULL, *Eps=VNULL,*K=VNULL;

/*----------------------------------Init--------------------------------------
 * Reports: OK, S_visuserv_MODULES_MISSING, S_visuserv_MODULES_NOT_INITIALIZED
 *              S_visuserv_POSTER_ERROR, S_visuserv_ROBOT_IS_MOVING	 */

//ACTIVITY_EVENT visuservInit(VISUSERV_POSTERS_STR * postersName, int *report)   
ACTIVITY_EVENT visuservInit(int *report)	//HUM2ICU
{
   /* Robot State (Moving or not):
  if (visuservMoving(SDI_F->postersID.effectorPosterID, report)!=OK){
    printf("visuservInitExec: robot is moving... stop it before!\n");
    return ETHER;
  }*/

  // reset robot state and control*/  
 // SDI_F->servoingRef.samplingTime=0;
 // SDI_F->servoingRef.numRef=0;
  
  // Now it's TRUE 
  SDI_F->state.visualServoingState      = VISUSERV_SERVOING_STOPPED;
  SDI_F->state.initDone                 = TRUE;

        JS=m_get(3,3);K=v_get(4);Eps=v_get(3);Cost=v_get(3);

	JS->me[0][0] = 1.0;		JS->me[1][0] = 1.0;	JS->me[2][0] = 1.0;
	JS->me[0][1] = 1.0;		JS->me[1][1] = 1.0;	JS->me[2][1] = 2.0;
	JS->me[0][2] = -1.0;		JS->me[1][2] = 2.0;	JS->me[2][2] = 2.0;

	Eps->ve[0] = 6.0;		Eps->ve[1] = 8.0;	Eps->ve[2] = 4.0;

	Cost->ve[0] = 2.0;		Cost->ve[1] = 10.0;	Cost->ve[2] = 8.0;

      //  K=Simplex(Eps, Cost, JS, VNULL); Simplex result : %lg , %lg , %lg , %lg  \n",K->ve[0],K->ve[1],K->ve[2],K->ve[3]

	printf (" VS - Init ok !!" );
	
	//strcpy(SDI_F->postersName.visualDataPosterName,postersName->visualDataPosterName);   //HUM2ICU
  return ETHER;
}

/*-------------------------------visuservServoingTaskInit-----------------------
 * Init visual servoing permanant task
 * Returns:    OK or ERROR						      */

STATUS visuservServoingTaskInit(int *report)
{
  
int i;	

	// Set names of used posters 
	//strcpy(SDI_F->postersName.visualDataPosterName,VISUSERV_DEFAULT_VISUALDATA_POSTERNAME_HUMTRACK); //HUM2ICU
	strcpy(SDI_F->postersName.visualDataPosterName,VISUSERV_DEFAULT_VISUALDATA_POSTERNAME_ICU);
	strcpy(SDI_F->postersName.robotPosterName,VISUSERV_DEFAULT_ROBOT_POSTERNAME);
	strcpy(SDI_F->postersName.effectorPosterName,VISUSERV_DEFAULT_EFFECTOR_POSTERNAME);
	strcpy(SDI_F->postersName.robotSpeedPosterName,VISUSERV_DEFAULT_ROBOTSPEED_POSTERNAME);
	strcpy(SDI_F->postersName.effectorSpeedPosterName,VISUSERV_DEFAULT_EFFECTORSPEED_POSTERNAME);
	
	// Default robot parameters 
	SDI_F->robotParams.vMax = VISUSERV_DEFAULT_VMAX;
	SDI_F->robotParams.wMax = VISUSERV_DEFAULT_WMAX;	
	SDI_F->robotParams.vMin = VISUSERV_DEFAULT_VMIN;
	SDI_F->robotParams.wMin = VISUSERV_DEFAULT_WMIN;
	SDI_F->robotParams.pMax = VISUSERV_MAX_PPMAX;
	SDI_F->robotParams.tMax = VISUSERV_MAX_TPMAX;
	SDI_F->robotParams.pMin = VISUSERV_MAX_PPMIN;
	SDI_F->robotParams.tMin = VISUSERV_MAX_TPMIN;
	SDI_F->robotParams.pVMax = VISUSERV_DEFAULT_PMAX;
	SDI_F->robotParams.tVMax = VISUSERV_DEFAULT_TMAX;
	SDI_F->robotParams.pVMin = VISUSERV_DEFAULT_PMIN;
	SDI_F->robotParams.tVMin = VISUSERV_DEFAULT_TMIN;
	
	// Default Visu	l servoing parameters
	SDI_F->visuservParams.vs_mode=VISUSERV_BOTH;
	// Default robot state
        SDI_F->state.targetRefIsDefined  = FALSE;
	SDI_F->state.initDone        	 = FALSE;
	SDI_F->state.onGoal          	 = FALSE;
	SDI_F->state.mustStop        	 = FALSE;
	SDI_F->state.visualServoingState = VISUSERV_DEFAULT_VISUAL_SERVOING_STATE;
	SDI_F->state.avoidanceState      = VISUSERV_DEFAULT_AVOIDANCE_STATE;	

	// Reset robot state and control*/
	SDI_F->servoingRef.q              =q_zero;
	q                                 =q_zero;
	SDI_F->servoingRef.dot_q          =dot_q_zero;
	SDI_F->servoingRef.dot_q_vs       =dot_q_zero;
	SDI_F->servoingRef.dot_q_obst     =dot_q_zero;
	SDI_F->servoingRef.dot_q_occlu    =dot_q_zero;
	dot_q                             =dot_q_zero;
	SDI_F->servoingRef.samplingTime=0;
	SDI_F->servoingRef.numRef=0;

	// Reset visual data poster*/
	for (i = 0; i< VISUSERV_VISUALDATA_MAX;i++)
	{s_zero.x[i] =0.0; s_zero.y[i] =0.0; s_zero.z[i] =0.0;}
	
  return OK;
}

/*-------------------------------------visuservServoingTaskEnd--------------------
 * Returns:    OK or ERROR						 	*/

STATUS visuservServoingTaskEnd(void)
{
  /* ... add your code here ... */

	return OK;
}

/*------------------------------visuservServoingTaskPerm--------------------------
 * Reports:    OK, S_visuserv_BAD_TARGET, S_visuserv_ROBOT_IS_MOVING
 *              S_visuserv_OBSTACLE_TOO_NEAR, S_visuserv_POSTER_ERROR
 * 
 * Returns:    OK or ERROR						 	*/

STATUS visuservServoingTaskPerm(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*----------------------- SET VisualServoing params (gains) -------------------------------------*
 * Set lambda i=1,3 for visuserv controller 							*
ACTIVITY_EVENT visuservSetParams(VISUSERV_ROBOT_GAINS_STR *gain, int *report)
{
	int i;

//	SDI_F->visuservParams.lambda[0] = SDI_F->lambda.Lv;
//	SDI_F->visuservParams.lambda[1] = SDI_F->lambda.Lw;
//	SDI_F->visuservParams.lambda[2] = SDI_F->lambda.Lp;
	printf("--  Set VS Gains ok -- \n");
	return ETHER;
}

/*----------------------------- SetRefTarget -------------------------------------
 * Set robot behind target then compute combinaison matrix from visual features
 * Reports:  OK, ,S_visuserv_NO_INIT, S_visuserv_ROBOT_IS_MOVING
 *              S_visuserv_NO_NEW_TARGET, S_visuserv_POSTER_ERROR	 	*/

ACTIVITY_EVENT visuservSetTarget(VISUSERV_ROBOT_GAINS_STR *lambda, int *report)
{
  int i,j,disp=0;

  // Verify init
  /*if (visuservServoingTaskInit(report)!=OK){
     printf("SetTarget: An error while attempt to (re)-initialize the module !\n");
    *report= S_visuserv_MODULES_NOT_INITIALIZED;
    return ETHER; }
*/
  // read visual data from ICU 		
   if(posterFind(SDI_F->postersName.visualDataPosterName,(POSTER_ID*)&SDI_F->postersID.visualDataPosterID)==ERROR) {
    printf ("SetTarget : Visual Features poster %s not found\n",SDI_F->postersName.visualDataPosterName);
    SDI_F->postersID.visualDataPosterID=-1;
    return END;  }

   // Read references from poster 
l1:  if (posterRead((POSTER_ID*)SDI_F->postersID.visualDataPosterID,0,(void *) &SDI_F->visualDataRef,sizeof(SDI_F->visualDataRef))==ERROR) 
  { printf ("SetTarget VisualFeatures poster read error \n");
  SDI_F->postersID.visualDataPosterID=-1;
  return END;  }

  // Target on or out test
    if ((SDI_F->visualDataRef.u==0)&&(SDI_F->visualDataRef.v==0)){
	if (disp==0) printf("SetTarget : No Target in image, just try again please ... \n"); disp=1; 
    /*return ETHER*/goto l1;} printf("\a");   // bip of target set done

  // Compute Global combinaison matrix (s=s*)
       Ccst=m_get(3,8);
    if (GetCombinaisonMatrix(SDI_F->visualDataRef,&Ccst)!=OK){
	printf("SetTarget : bad parameter for Combinaison matrix:%d\n");
    return ETHER;} 

   for (i = 0; i < 4 ; i++){ SDI_F->visualDataRef.z[i]=1.00;} 
   printf("\n Target visible : uc = %.2f |vc = %.2f |zc= %.2f |sc=%.2f \n\n",SDI_F->visualDataRef.u,SDI_F->visualDataRef.v,SDI_F->visualDataRef.z[0],SDI_F->visualDataRef.scale);

   printf("xo = %.2f |yo = %.2f |zo= %.2f \n",SDI_F->visualDataRef.x[0],SDI_F->visualDataRef.y[0],SDI_F->visualDataRef.z[0]);
   printf("x1 = %.2f |y1 = %.2f |z1= %.2f \n",SDI_F->visualDataRef.x[1],SDI_F->visualDataRef.y[1],SDI_F->visualDataRef.z[1]);
   printf("x2 = %.2f |y2 = %.2f |z2= %.2f \n",SDI_F->visualDataRef.x[2],SDI_F->visualDataRef.y[2],SDI_F->visualDataRef.z[2]);
   printf("x3 = %.2f |y3 = %.2f |z3= %.2f \n",SDI_F->visualDataRef.x[3],SDI_F->visualDataRef.y[3],SDI_F->visualDataRef.z[3]);
   printf("Ccst =\n"); for (i = 0; i < 3 ; i++){for (j=0; j < 8; j++) printf(" %lg |",Ccst->me[i][j]);printf("\n");}
   printf("---  Set Target ok--- \n");

  // Set_target State
   SDI_F->state.targetRefIsDefined = TRUE;
   SDI_F->state.onGoal=FALSE;
   
  return ETHER;
}

/* -------------------------- Start ------------------------------*/
ACTIVITY_EVENT visuservVisualServoingStart(VISUSERV_VISUAL_SERVOING_PARAMS_STR *visuservParams,int *report)
{

//    ICU_VISUAL_DATA 	visualDataOld;  
   int i,j; 

   // test if lambda gains are defined 
  if (SDI_F->visuservParams.lambda[0]*SDI_F->visuservParams.lambda[1]*SDI_F->visuservParams.lambda[2]==0) {
    printf("VisualServoingStart: Lambda null or not defined ...\n");
    return END; } else   {  
			// normalise visuserv lambda gains
			if (visuservParams->vs_type==VISUSERV_BASIC) {
			SDI_F->visuservParams.lambda[0]=SDI_F->visuservParams.lambda[0]/100000;
		   	SDI_F->visuservParams.lambda[1]=SDI_F->visuservParams.lambda[1]/100000;
		    	SDI_F->visuservParams.lambda[2]=SDI_F->visuservParams.lambda[2]/1000;	
			} else   {
			SDI_F->visuservParams.lambda[0]=SDI_F->visuservParams.lambda[0]/100;
		   	SDI_F->visuservParams.lambda[1]=SDI_F->visuservParams.lambda[1]/100;
		    	SDI_F->visuservParams.lambda[2]=SDI_F->visuservParams.lambda[2]/100;	}
			}

 // test if reference target is defined 
  if (SDI_F->state.targetRefIsDefined==FALSE) {
    *report = S_visuserv_NO_REF_TARGET  ;
    printf("VisualServoingStart: Target not defined ...\n");
    return END; }

   // visual data reset 
	SDI_F->visualDataOld = s_zero;
	SDI_F->visualDataMes = s_zero;
	SDI_F->visualDataEst = s_zero;
	q     = q_zero; ss=0;
	dot_q = dot_q_zero; 
	dot_q_old = dot_q_zero; 
  	C=m_get(3,8);  	Cvar=m_get(3,8);

   // Find posters and set s_old
  if(posterFind(SDI_F->postersName.effectorSpeedPosterName,(POSTER_ID*)&SDI_F->postersID.effectorSpeedPosterID)!=OK){   
    *report =  S_visuserv_POSTER_ERROR;
    printf( "VisualServoingStart :  poster ^ %s ^ not found \n", SDI_F->postersName.effectorSpeedPosterName);
    return ETHER; }

  if(posterFind(SDI_F->postersName.visualDataPosterName,(POSTER_ID*)&SDI_F->postersID.visualDataPosterID)!=OK){
    *report =  S_visuserv_POSTER_ERROR;
    printf( "VisualServoingStart :  poster ^ %s ^ not found \n",SDI_F->postersName.visualDataPosterName);
    return ETHER; }

  if(posterRead((POSTER_ID*)SDI_F->postersID.visualDataPosterID,0,(void *) &SDI_F->visualDataOld,sizeof(SDI_F->visualDataOld))==ERROR) {   printf ("VisualServoingStart : visual features poster read error \n");
   SDI_F->postersID.visualDataPosterID=-1;
   return END;  }
   
  //Data file open and initialize   
	vsData=fopen("/home/nouadah/DATA/vs.log","w"); 

	// L type
    	if (visuservParams->vs_mode==VISUSERV_CONSTANT_INTER_MTRX) fprintf(vsData," L=%d;   % L Cst ,",1);
       	else if (visuservParams->vs_mode==VISUSERV_BOTH) fprintf(vsData," L=%d;   % L Both ,",3); 
	else fprintf(vsData," L=%d;  % L Var  ,",2); 	

	// Control type
	if (visuservParams->vs_type==VISUSERV_SLIDING_CONTROLER)  fprintf(vsData," VS Sliding ,"); // sliding mode controller
   	else if (visuservParams->vs_type==VISUSERV_COMBINED)  fprintf(vsData," VS Combined ,");// sliding + classical
 	else if (visuservParams->vs_type==VISUSERV_DYNAMIC)  fprintf(vsData," VS Sliding new ,");// new sliding controller    		
	else fprintf(vsData," VS Basic ,"); // classical vs controller 

	//* SM type
    	if (visuservParams->sm_type == VISUSERV_SLIDING_1_SIGN) fprintf(vsData," \n sm=%d;   %  Sign ",1);
       	else if (visuservParams->sm_type == VISUSERV_SLIDING_2_SAT) fprintf(vsData," \n sm=%d;  %  Sat ",2); 
	else fprintf(vsData," \n sm=%d;  %  Smooth ",3); //*/	

   fprintf(vsData,"Lambda1= %lg ;Lambda2= %lg ;Lambda3= %lg;\n \n   uc=%.1f ;  vc=%.1f ; scale=%.3f;\n",SDI_F->visuservParams.lambda[0],SDI_F->visuservParams.lambda[1],SDI_F->visuservParams.lambda[2],SDI_F->visualDataRef.u,SDI_F->visualDataRef.v,SDI_F->visualDataRef.scale);
   fprintf(vsData,"\n % Tmp    vr       wr       wp      u      v     Scale    Ec      pan     TF123    etat   z  tilt  TFP123 Lambda123  Theta_RFID   Z_RFID \n\n A=[ \n");

  //reset ref counter
  SDI_F->servoingRef.numRef = 0;
  visualServoing_watchdog= 0;
  
  /*Now we are sure that robot is stopped*/
  SDI_F->state.visualServoingState = VISUSERV_SERVOING_STOPPED;
  SDI_F->state.onGoal=FALSE;
  
  /*RAZ controllers*/
 SDI_F->servoingRef.dot_q	=dot_q_zero;
 printf("----------------------reste all ok ------------------------\n \n");

return EXEC;
}

/* ---------------------------- Exec -----------------------------*/
ACTIVITY_EVENT visuservVisualServoingExec(VISUSERV_VISUAL_SERVOING_PARAMS_STR *visuservParams, int *report)
{
  PLATINE_STATES   			effector;
  VISUSERV_ROBOT_CONTROLS_STR 		dot_q,dot_q_old;
  GENPOS_CART_SPEED 			robotRef;    
  VISUSERV_ROBOT_CONFIGURATION_STR 	q;
  STATUS 				status;
  int offset=0, i,j,reply, need_estim=0, have_s=1,L_type=0; 
  static int disp=1;	 
  double Ec,Sc=2.2,pc=0.2,pr=0.0,panr=0.0;

    // Read visual data
   if (posterRead((POSTER_ID*)SDI_F->postersID.visualDataPosterID,0,(void *) &SDI_F->visualDataMes,sizeof(SDI_F->visualDataMes))==ERROR) {   printf ("VisualServoingExec: poster read error \n");
   SDI_F->postersID.visualDataPosterID=-1;
   return END;  }

// read pan position from platine	
   if(posterRead((POSTER_ID*)SDI_F->postersID.effectorSpeedPosterID,0,(void *) &effector,sizeof(effector))==ERROR) 
   { printf (" VisualServoingExec: error on poster in pan read \n");
    return END;  }

  // face Center position error
    //Ec=sqrt(pow((SDI_F->visualDataMes.u-SDI_F->visualDataRef.u),2)+pow((SDI_F->visualDataMes.v-SDI_F->visualDataRef.v),2));
     Ec= SDI_F->visualDataMes.u-SDI_F->visualDataRef.u;

  // TIME MESURE
      gettimeofday (&tr_tmp, NULL);
      if (tr_tmp.tv_usec >= useca) { dt = (tr_tmp.tv_sec-seca)*1000.0 + (tr_tmp.tv_usec-useca)/1000.0 ;}	
        else { dt = (tr_tmp.tv_sec-seca-1)*1000.0 + (1000000+tr_tmp.tv_usec-useca)/1000.0 ;	}
      seca=tr_tmp.tv_sec; 	useca=tr_tmp.tv_usec; 	if (dt<2000) tmp=tmp+dt;

  // Is target visible or robot on goal?!
  if (SDI_F->visualDataMes.u==0) { // No target ->put control null or go recover target
	if (disp==1) { printf( " ************ NO TARGET ***********\n ");  disp=0;}

	if (fabs(effector.stateDeg.pos.pan-SDI_F->visualDataMes.rfidT)>10 & SDI_F->visualDataMes.rfidZ>=0)  { // recovering user
	pr=-pc*Sign(effector.stateDeg.pos.pan-SDI_F->visualDataMes.rfidT); 
	printf( " Recover-> Teta: %lg ,ppos =%.3f ,p=%.3f ,tm= %.3f \n ",SDI_F->visualDataMes.rfidT, effector.stateDeg.pos.pan, pr,tmp); }
		else  pr=0;
	// HUM2ICU	if (fabs(effector.stateDeg.pos.pan)>10&)  panr=-0.2*Sign(effector.stateRad.pos.pan);    else  panr=0; 

		//fprintf(vsData," %.2f , %lg , %lg , %lg , %.1f , %.1f , %.3f , %.2f , %.3f , %lg ,%lg , %lg , %d , %.3f, %lg, %lg, %lg, %lg , %lg, %lg, %lg, %lg, %lg\n",tmp ,pr,panr ,pr ,SDI_F->visualDataMes.u ,SDI_F->visualDataMes.v ,SDI_F->visualDataMes.scale, Ec, effector.stateRad.pos.pan,pr,pr,pr,pr,SDI_F->visualDataMes.z[i],pr,pr,pr,pr,pr,pr,pr,SDI_F->visualDataMes.rfidT,SDI_F->visualDataMes.rfidZ);

	SDI_F->robotRef.v = 0;   SDI_F->robotRef.w = pr;  SDI_F->effectorRef.tilt = 0; SDI_F->effectorRef.pan = panr;
	SDI_F->robotRef.vmax = 1.0;   	SDI_F->robotRef.wmax = 1.0;  	//tmp=0.0;
	SDI_F->robotRef.linAccelMax = 0.5;   	SDI_F->robotRef.angAccelMax = 0.5*(6. * M_PI / 2.)/2;	
			return EXEC;	}

  else { if (disp==0) SDI_F->visualDataOld=SDI_F->visualDataMes; disp=1;// target visible 

  //  Interaction Matrix Mode :  
	if (visuservParams->vs_mode==VISUSERV_CONSTANT_INTER_MTRX) {   
		for (i=0; i< 3;i++ ){for (j=0; j< 8;j++ ){ C->me[i][j] = Ccst->me[i][j];}}}
	else if (visuservParams->vs_mode==VISUSERV_BOTH) {  GetCombinaisonMatrix(SDI_F->visualDataMes,&Cvar); 
		for (i=0; i< 3;i++ ){for (j=0; j< 8;j++ ){ C->me[i][j] = (double)((Ccst->me[i][j]+Cvar->me[i][j])/2);}}}
	else {  GetCombinaisonMatrix(SDI_F->visualDataMes,&Cvar); 
	for (i=0; i< 3;i++ ){for (j=0; j< 8;j++ ){ C->me[i][j] = Cvar->me[i][j];}}} 
	
  //   Controller Type :  
   if (visuservParams->vs_type==VISUSERV_SLIDING_CONTROLER) {   // sliding mode controller : SM
  	if (smController(effector.stateRad.pos.pan,C,SDI_F->visualDataRef,SDI_F->visualDataMes,SDI_F->visualDataOld,SDI_F->robotSpeeds,SDI_F->visuservParams,&dot_q,&SDI_F->state)!=OK){  SDI_F->state.visualServoingState=VISUSERV_SERVOING_FAIL;      
  	*report= S_visuserv_SERVOING_ERROR;      
  	return END; }
	}  
   else if (visuservParams->vs_type==VISUSERV_COMBINED)  {   // Sliding mode + classical controller : SM2 
	if (sm2Controller(effector.stateRad.pos.pan,C,SDI_F->visualDataRef,SDI_F->visualDataMes,SDI_F->visualDataOld,SDI_F->robotSpeeds,SDI_F->visuservParams,&dot_q,&SDI_F->state)!=OK){  SDI_F->state.visualServoingState=VISUSERV_SERVOING_FAIL;      
	*report= S_visuserv_SERVOING_ERROR;      
	return END; }
	}
   else if (visuservParams->vs_type==VISUSERV_DYNAMIC)  {   // new SM controller:  SM3
  	if (sm3Controller(effector.stateRad.pos.pan,C,SDI_F->visualDataRef,SDI_F->visualDataMes,SDI_F->visualDataOld,SDI_F->visuservParams,&dot_q,&SDI_F->state)!=OK){  SDI_F->state.visualServoingState=VISUSERV_SERVOING_FAIL;      
	*report= S_visuserv_SERVOING_ERROR;   
	return END; }
	}
   else {   // classical controller (ds/dt = 0) : VS
  	if (vsController(effector.stateRad.pos.pan,pan_old,C,SDI_F->visualDataRef,SDI_F->visualDataMes,SDI_F->visualDataOld,SDI_F->visuservParams,dot_q_old,&dot_q,&SDI_F->state)!=OK){
	SDI_F->state.visualServoingState=VISUSERV_SERVOING_FAIL;      
	*report= S_visuserv_SERVOING_ERROR;      
	return END; }
	} 

	/* linear velocity control (with respec to target scale)
	Sc = (SDI_F->visualDataMes.scale - 2.2);
	if (SDI_F->state.onGoal==0)  dot_q.vr = -0.35*(Sc);  else dot_q.vr=0; 	  
	if (dot_q.vr> 0.4)     {dot_q.vr = 0.4;  printf ("Vr+");} 
	if (dot_q.vr< -0.4)     {dot_q.vr = -0.4; printf ("Vr-");} */

	printf("|ss=%d t=%.2f|E=%.1f\n",ss,tmp/1000.0,Ec);
	 } // test target visible end

	// Is robot on goal or not yet ? 	printf("---av envoi---\n");	
	if (SDI_F->state.onGoal==0) { ss=0;
	SDI_F->state.visualServoingState =VISUSERV_SERVOING_MOTION;
	SDI_F->robotSpeeds=dot_q;
	SDI_F->visualDataOld = SDI_F->visualDataMes;
	dot_q_old=dot_q;
	pan_old=effector.stateRad.pos.pan;

	// Write control variables in posters (- sur vr HUM2ICU)
	SDI_F->robotRef.v = (dot_q.vr); 	SDI_F->robotRef.w = dot_q.wr;		SDI_F->effectorRef.pan = dot_q.p; 
	SDI_F->effectorRef.tilt = 0; 		SDI_F->robotRef.vmax = 1.0;   		SDI_F->robotRef.wmax = 1.0;
	SDI_F->robotRef.linAccelMax = 1.0;   		//1.0
	SDI_F->robotRef.angAccelMax = 0.5*(6.*M_PI/2.);		//0.5*(6. * M_PI / 2.)
	if (SDI_F->visualDataMes.u!=0) fprintf(vsData," %.2f , %lg , %lg , %lg , %.1f , %.1f , %.3f , %.2f , %.3f , %lg ,%lg , %lg , %d , %.3f, %lg , %lg, %lg, %lg , %lg, %lg, %lg, %lg, %lg\n",tmp ,dot_q.vr ,dot_q.wr ,dot_q.p ,SDI_F->visualDataMes.u ,SDI_F->visualDataMes.v ,SDI_F->visualDataMes.scale, Ec,effector.stateRad.pos.pan,SDI_F->state.TF[0],SDI_F->state.TF[1],SDI_F->state.TF[2],SDI_F->state.onGoal,SDI_F->visualDataMes.z[i],dot_q.t,SDI_F->state.TFP[0],SDI_F->state.TFP[1],SDI_F->state.TFP[2],SDI_F->state.KSM[0],SDI_F->state.KSM[1],SDI_F->state.KSM[2],SDI_F->visualDataMes.rfidT,SDI_F->visualDataMes.rfidZ);
	// Reset state 
	for (i=0; i<3; i++)  { SDI_F->state.TFP[i]=0; SDI_F->state.KSM[i]=0;}

	return EXEC;		    }

	else { ss++; 	printf("\a"); // robot converges -> put control null 
	SDI_F->robotRef.v = 0;   SDI_F->robotRef.w = 0;  SDI_F->effectorRef.pan = 0; SDI_F->effectorRef.tilt = 0;
	SDI_F->robotRef.vmax = 1.0;   	SDI_F->robotRef.wmax = 1.0;
	SDI_F->robotRef.linAccelMax = 1.0;   	SDI_F->robotRef.angAccelMax = 0.5*(6. * M_PI / 2.);	
	if (SDI_F->visualDataMes.u!=0) fprintf(vsData," %.2f , %lg , %lg , %lg , %.1f , %.1f , %.3f , %.2f , %.3f , %lg ,%lg , %lg , %d , %.3f, %lg, %lg, %lg, %lg , %lg, %lg, %lg, %lg, %lg\n",tmp ,dot_q.vr ,dot_q.wr ,dot_q.p ,SDI_F->visualDataMes.u ,SDI_F->visualDataMes.v ,SDI_F->visualDataMes.scale, Ec,effector.stateRad.pos.pan,SDI_F->state.TF[0],SDI_F->state.TF[1],SDI_F->state.TF[2],SDI_F->state.onGoal,SDI_F->visualDataMes.z[i],dot_q.t,SDI_F->state.TFP[0],SDI_F->state.TFP[1],SDI_F->state.TFP[2],SDI_F->state.KSM[0],SDI_F->state.KSM[1],SDI_F->state.KSM[2],SDI_F->visualDataMes.rfidT,SDI_F->visualDataMes.rfidZ);	  
	    if (ss<8) return EXEC; else  { printf (" \n Robot Converges well: s=%d \n",ss); return END;}
	     }

}

/* ------------------------------ End ---------------------------------*/
ACTIVITY_EVENT visuservVisualServoingEnd(VISUSERV_VISUAL_SERVOING_PARAMS_STR *visuservParams,int *report)
{
	
	// close data file  
//	if (vsData!=NULL) {fprintf(vsData,"];\n\n --- ALL OK ---\n"); fclose(vsData); } 

  return ETHER;
}

/* ---------------------------- Fail --------------------------------*/
ACTIVITY_EVENT visuservVisualServoingFail(VISUSERV_VISUAL_SERVOING_PARAMS_STR *visuservParams,int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* ---------------------------- Inter ----------------------------------*/
ACTIVITY_EVENT visuservVisualServoingInter(VISUSERV_VISUAL_SERVOING_PARAMS_STR *visuservParams,int *report)
{
  /* ... add your code here ... */
  return ETHER;
}


/*------------------------------------------- STOP  ------------------------------------------*/
STATUS visuservStop(int *report)
{
	// Write control variables in posters
	SDI_F->robotRef.v = 0;    	
	SDI_F->robotRef.w = 0;
	SDI_F->effectorRef.pan = 0;    	
	SDI_F->effectorRef.tilt = 0;

	//time reset
	tmp=0.0;ti=0.0;

	SDI_F->state.visualServoingState      = VISUSERV_SERVOING_STOPPED;
	

	// close data files 	
	if (ptData!=NULL) {fprintf(ptData,"];\n\n  %%   ALL OK ---\n"); fclose(ptData); } 
	if (vsData!=NULL) {fprintf(vsData,"];\n\n  %%   ALL OK ---\n"); fclose(vsData); } 

	printf("  ---------- Visuserv STOPPED ------------- \n");

  return OK;
}
/*---------------------------------------- TRACK -----------------------------------------------
 * Reports: OK, S_visuserv_NO_INIT, S_visuserv_POSTER_ERROR, S_visuserv_BAD_TARGET
 * Reports: OK, S_visuserv_POSTER_NOT_FOUND, S_visuserv_NO_INIT		*/

/* ----------- visuservTrackStart ------------ */
ACTIVITY_EVENT visuservTrackStart(VISUSERV_TRACK_PARAMS_STR *trackParams, int *report)
{
    
  sep=0.0;   set=0.0;   epa=0.0;   eta=0.0;  tmp=0.0;
  
  /* Poster find : */
  if(posterFind(SDI_F->postersName.visualDataPosterName,(POSTER_ID*)&SDI_F->postersID.visualDataPosterID) == ERROR) {   SDI_F->postersID.visualDataPosterID = -1;
    *report = S_visuserv_POSTER_ERROR;
    printf ("TrackStart: poster %s not found\n",SDI_F->postersName.visualDataPosterName);
  return ETHER;  }

   ptData=fopen("/home/nouadah/DATA/track.log","w"); 
  
//   fprintf(ptData,"Track pan : kp= %.2f , ki=%.2f , kd=%.1f \n   Pan    Ep  Ep_old   S_Ep \n\n A=[",SDI_F->trackParams.panKp,SDI_F->trackParams.panKi,SDI_F->trackParams.panKd);
   fprintf(ptData,"% Track PAN: kp= %.2f , ki=%.2f , kd=%.1f \n %  TILT: kp= %.2f , ki=%.2f , kd=%.1f \n  % DATA:t  Pan   Ep   S_ep   Tilt   Et   S_et   RFIDT  RFIDZ   Uc   Vc  v  w  scale \n\n A=[\n",SDI_F->trackParams.panKp,SDI_F->trackParams.panKi,SDI_F->trackParams.panKd,SDI_F->trackParams.tiltKp,SDI_F->trackParams.tiltKi,SDI_F->trackParams.tiltKd);

   // start time   gettimeofday (&tr_tmp, NULL); 	seca=tr_tmp.tv_sec; useca=tr_tmp.tv_usec;

   // read pan position from platine	
    if(posterFind(SDI_F->postersName.effectorSpeedPosterName,(POSTER_ID*)&SDI_F->postersID.effectorSpeedPosterID)==ERROR) {
    printf ("Read pan: poster %s not found\n",SDI_F->postersName.effectorSpeedPosterName);
    return END;  }
 

  return EXEC;
}

/* ----------- visuservTrackExec ------------ */
ACTIVITY_EVENT visuservTrackExec(VISUSERV_TRACK_PARAMS_STR *trackParams, int *report)
{
  ICU_VISUAL_DATA 	visualData;
  PLATINE_STATES effector;
  double p=0,t=0,wr=0,vr=0,vra=0,ep,et,max=0.6,tt,pc=0.3,tc=0.05,panp,tiltp,scale; 
  static double tta=9999999,rfidTa=99999999;
  static int disp=1;

  /* Read references from poster */
  if (posterRead((POSTER_ID*)SDI_F->postersID.visualDataPosterID,0,(void *) &visualData,sizeof(ICU_VISUAL_DATA))==ERROR) { SDI_F->postersID.visualDataPosterID=-1;
         *report = S_visuserv_POSTER_ERROR;
    return ETHER;  }
	  
   // TIME MESURE
	gettimeofday (&tr_tmp, NULL);
	if (tr_tmp.tv_usec >= useca) { dt = (tr_tmp.tv_sec-seca)*1000.0 + (tr_tmp.tv_usec-useca)/1000.0 ;}	
	else { dt = (tr_tmp.tv_sec-seca-1)*1000.0 + (1000000+tr_tmp.tv_usec-useca)/1000.0 ;	}
	seca=tr_tmp.tv_sec; 	useca=tr_tmp.tv_usec; 	if (dt<200) tmp=tmp+dt;

   // platine pan
    if(posterRead((POSTER_ID*)SDI_F->postersID.effectorSpeedPosterID,0,(void *) &effector,sizeof(effector))==ERROR) 
    { printf ("Read pan: poster read error \n");
    return END;  }
    panp=effector.stateDeg.pos.pan;      tiltp=effector.stateDeg.pos.tilt;

    // PAN TILT PID Controllers 
        if (visualData.u*visualData.v==0)  {
		sep=0.0;set=0.0;epa=0.0;eta=0.0;   //, variables reset
		
		//No detection --> Do nothing 
		if (visualData.rfidT==-1) {p=0;t=0; 
		if (disp==1) { printf("Target invisible: panp=%.2f |RFID= %.2f , %.2f |tiltp= %.2f",panp,visualData.rfidT,visualData.rfidZ,tiltp);
			       printf( "-- NO RFID DETECTION --:");disp=0;}
				 	}
		/*RFID CONTROLE*/ 
		else  { disp=1;printf("No Target:|RFID= %.2f , %.2f|panp=%.2f |tiltp= %.2f ",visualData.rfidT,visualData.rfidZ,panp,tiltp);  
   		if (abs(panp-visualData.rfidT)>10)  p=-pc*Sign(panp-visualData.rfidT); else  p=0; 
     		if (tiltp<-10)  t=-0.2*Sign(tiltp);    else  t=0; 
		printf(" RFID->P= %.1f |T=%.1f |tmp=%.2f ",p,t,tmp/1000); 
		rfidTa=visualData.rfidT;}
					   }
        else   {	ep=160-visualData.u ;		sep=sep+ep; 	disp=1; 	
			et=90-visualData.v; 		set=set+et;   // 60 ok for RFID
	
	p = SDI_F->trackParams.panKp*ep/1000  + SDI_F->trackParams.panKi*sep/10000 + SDI_F->trackParams.panKd*(ep-epa)/1000; 
	t = SDI_F->trackParams.tiltKp*et/1000 + SDI_F->trackParams.tiltKi*set/10000 + SDI_F->trackParams.tiltKd*(et-eta)/1000; 

	/* Pan*/  if ((ep>0)&(p>max))  		{ p=max;	sep=sep-ep;printf("-PMax-");}
		else if ((ep<0)&(p<-max))  	{ p=-max;	sep=sep-ep;printf("-PMin-");}
 	/* Tilt*/ if ((et>0)&(t>max))  		{ t=max;	set=set-et;printf("-TMax-");}
	  	else if ((et<0)&(t<-max))  	{ t=-max;	set=set-et;printf("-TMin-");}

 	printf("P= %.2f |Ui= %.2f | ",p,ep);
 	printf("T= %.2f |Vi= %.2f | tmp= %.2f |RFID= %.2f , %.2f",t,et,tmp/1000,visualData.rfidT,visualData.rfidZ);
	epa=ep; eta=et;			}

	// Modes selection (PTU here)
	if (trackParams->tr_mode==VISUSERV_TRACK_PANTILT) { 
	fprintf(ptData,"      %.4f , %.2f , %.1f , %.1f , %.2f , %.1f , %.1f , %.2f , %.2f , %.1f , %.1f; \n",  tmp,p ,ep ,sep ,t ,et ,set ,visualData.rfidT,visualData.rfidZ,visualData.u ,visualData.v);
	printf("|Pp=%.1f |Tp=%.1f PTU\n",panp,tiltp); 
	SDI_F->effectorRef.pan = p;    		SDI_F->effectorRef.tilt = t;
	return EXEC;
	}
  // Evitement de sortie par rotation de la platine: XXXXXXXXXXXXXXXXX TO DO SDI_F->visualDataRef.scale
// use pan to avoid target out of image 
//	if (abs(ep)<10000) p=0;
   /*	if ((abs(panp)>45)&(visualData.u*visualData.v!=0))	{ vr = 0; wr = 0.1*Sign(panp);	}
	else 							{ vr = 0; wr = 0; }wr = (double)(abs(p)*Sign(panp)/2.0);*/	
	
   // Speed control : if (SDI_F->state.targetRefIsDefined==TRUE){
	/* ICU */
	if (visualData.u!=0) { wr=p; scale = (visualData.scale - 2.3);
		if ((scale<=-0.1)||(scale>=0.1))  vr = 0.4*(scale-0.1*Sign(scale)); else vr=0; }
	/* RFID */
	else if ((visualData.u==0)&(visualData.rfidT!=-1)) { wr=p;   //XXXXXXXXXXX a revoir continuite
	 	if ((visualData.rfidZ>200)&(abs(visualData.rfidT)<60))  vr = (double) (-0.15*visualData.rfidZ/300); 
	 
		else if ((visualData.rfidZ>200)&(abs(visualData.rfidT)>120)) {vr = (double)(0.15*visualData.rfidZ/300); 
		/*evit discnt*/	if (abs(vra-vr)>0.1) vr = vra - Sign(vra-vr)*0.1;   }      
		else  vr = 0;  }		
 	/* No detection */
 	else  { vr = 0;    wr = 0; }
    fprintf(ptData,"      %.4f , %.2f , %.1f , %.1f , %.2f , %.1f , %.1f , %.2f , %.2f , %.1f , %.1f , %.2f ,  %.2f , %.3f; \n",  tmp,p ,ep ,sep ,t ,et ,set ,visualData.rfidT,visualData.rfidZ,visualData.u ,visualData.v,vr,wr,scale);	
	
//	}    else  { vr = 0;    wr = 0;   printf(" Target not defined yet ,,, !!! \n");     return END;}	
							
        if ((visualData.u!=0)||(visualData.rfidT!=-1)) { 
	printf("|Pp=%.1f |Tp=%.1f |v= %.2f |w= %.2f |sc= %.3f , %.3f ROBOT\n",panp,tiltp,vr,wr,scale,SDI_F->visualDataRef.scale);} 

	// robot velocities saturation:
	if (vr>= 0.4)   {vr = 0.4;  printf (" V+");}  	if (vr<= -0.4)  {vr = -0.4;  printf (" V-");} 
	if (wr>= 0.4)   {wr = 0.4;  printf (" W+");} 	if (wr<= -0.4)  {wr = -0.4;  printf (" W-");} 
	
	// Old speed refrech
	vra=vr;	

	SDI_F->effectorRef.pan = 0*p;    	SDI_F->effectorRef.tilt = t;
	SDI_F->robotRef.v = -vr;    		SDI_F->robotRef.w = wr;   //HUM2ICU (le -)
    	SDI_F->robotRef.vmax = 1.0;   		SDI_F->robotRef.wmax = 1.0;
	SDI_F->robotRef.linAccelMax = 1.0;   		//1.0
	SDI_F->robotRef.angAccelMax = 0.5*(6.*M_PI/2.);		//0.5*(6. * M_PI / 2.)  
 
      return EXEC;
}
/*---------------------------- Avoid : Used to move the robot only -----------------------------
/*------------------------------------------------------------------------------- --------------
 * Description: faire bouger le robot uniquement
 *
 * Reports:OK,S_visuserv_NO_INIT,S_visuserv_POSTER_ERROR,S_visuserv_BAD_PARAMS
 * S_visuserv_OBSTACLE_TOO_NEAR, S_visuserv_FILE_ERROR, 		*/

/* -------------- Start  ------------------- */
ACTIVITY_EVENT visuservAvoidStart(VISUSERV_ROBOT_CONTROLS_STR *robotSpeeds, int *report)
{
        SDI_F->robotRef.v = 0.0;   	
	SDI_F->robotRef.w = 0.0;
	SDI_F->effectorRef.pan = 0.0;    	
	SDI_F->effectorRef.tilt = 0.0;
	if (vsData!=NULL) {fprintf(vsData,"];\n\n  %%   ALL OK ---\n"); fclose(vsData); } 
        printf("Avoid : Moving robot with  v= %.2f | w= %.2f  \n",SDI_F->robotSpeeds.vr,SDI_F->robotSpeeds.wr);
  return EXEC;
}

/* ----------------- Exec  ------------------ */
ACTIVITY_EVENT visuservAvoidExec(VISUSERV_ROBOT_CONTROLS_STR *robotSpeeds, int *report)
{
	
	// robot and platine velocities saturation for safety:
	if (SDI_F->robotSpeeds.vr>= 0.3)    {SDI_F->robotSpeeds.vr = 0.3;  printf (" V+\n");} 
	if (SDI_F->robotSpeeds.vr<= -0.3)   {SDI_F->robotSpeeds.vr = -0.3;  printf (" V-\n");} 

	if (SDI_F->robotSpeeds.wr>= 0.3)   {SDI_F->robotSpeeds.wr = 0.3;  printf (" W+\n");} 
	if (SDI_F->robotSpeeds.wr<= -0.3)  {SDI_F->robotSpeeds.wr = -0.3;  printf (" W-\n");} 
	
	if (SDI_F->robotSpeeds.p>= 0.6)    {SDI_F->robotSpeeds.p = 0.6;  printf (" V+\n");} 
	if (SDI_F->robotSpeeds.p<= -0.6)   {SDI_F->robotSpeeds.p = -0.6;  printf (" V-\n");} 

	if (SDI_F->robotSpeeds.t>= 0.6)   {SDI_F->robotSpeeds.t = 0.6;  printf (" W+\n");} 
	if (SDI_F->robotSpeeds.t<= -0.6)  {SDI_F->robotSpeeds.t = -0.6;  printf (" W-\n");} 

	// Send commands
	SDI_F->robotRef.v = SDI_F->robotSpeeds.vr;    	 	SDI_F->robotRef.w = SDI_F->robotSpeeds.wr;
	SDI_F->effectorRef.pan = SDI_F->robotSpeeds.p; 		SDI_F->effectorRef.tilt = SDI_F->robotSpeeds.t;
	SDI_F->robotRef.vmax = 1.0;   		SDI_F->robotRef.wmax = 1.0;
	SDI_F->robotRef.linAccelMax = 1.0;   			//1.0
	SDI_F->robotRef.angAccelMax = 0.5*(6. * M_PI / 2.);	//0.5*(6. * M_PI / 2.)
 
  return EXEC;
}

/* -------------- End  ------------------*/
ACTIVITY_EVENT visuservAvoidEnd(VISUSERV_ROBOT_CONTROLS_STR *robotSpeeds, int *report)
{
  /* ... add your code here ... */
  return ETHER;
}
/* ------------------------------------------- END ---------------------------------------------*/

